--#inherit BoilerConfig;
package FaultIntegrator is
   type T is limited private;
   --# function currthreshold(FI : T) return Positive;
   --# function numeventipositivi(FI : T) return Natural;
   --# -- guarda gli ultimi...
   --# function tripped(FI : T) return Boolean;
   procedure Init (FI : out T; Threshold : in Positive);
   --# derives FI
   --#    from Threshold;
   --# post currthreshold(fi) = threshold
   --#  and numeventipositivi(fi) = 0
   --#  and not tripped(fi)
   --# ;
   procedure Test
     (FI              : in out T;
      CurrentEvent    : in Boolean;
      IntegratedEvent : out Boolean);
   --# derives IntegratedEvent,
   --#         FI
   --#    from FI,
   --#         CurrentEvent;
   --# pre  numeventipositivi(fi) <= currthreshold(fi)
   --# ;
   --# post (currentevent
   --#           ->    ((numeventipositivi(fi~) < currthreshold(fi~)
   --#                   ->    (numeventipositivi(fi) = numeventipositivi(fi~)+1
   --#                    and (tripped(fi) <-> tripped(fi~))) )
   --#             and (numeventipositivi(fi~) = currthreshold(fi~)
   --#                   -> tripped(fi) )))
   --#  and (not currentevent
   --#         ->      ((numeventipositivi(fi~) > 0
   --#                   ->    (numeventipositivi(fi) = numeventipositivi(fi~)-1
   --#                 and (tripped(fi) <-> tripped(fi~))) )
   --#             and (numeventipositivi(fi~) = 0
   --#                   -> (not tripped(fi)) )))
   --#  and -- invarianza della soglia
   --#      (currthreshold(fi~) = currthreshold(fi))
   --#   --    and (numeventipositivi(fi) <= currthreshold(fi))
   --# ;
private
   type T is record
      Limit   : Positive;
      Counter : Natural;
      Tripped : Boolean;
   end record;
end FaultIntegrator;
